unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Sockets, StdCtrls;

type
  TMyThread = class(TThread)
    protected
      procedure Execute; override;
end;   

type
  TForm1 = class(TForm)
    Button1: TButton; 
    TcpClient1: TTcpClient;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    procedure Button1Click(Sender: TObject);
    procedure OnDataReceive(Sender: TObject; Buf: PAnsiChar;
      var DataLen: Integer);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  MyThread: TMyThread;
  buffer: string;
  CRbyte: Shortint;
  LFbyte: Shortint;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin

  TcpClient1.RemoteHost := '192.168.0.101';
  TcpClient1.RemotePort := '2424';

  TcpClient1.Open;

  CRbyte := 13; // HEX 0x0D
  LFbyte := 10; // HEX 0x0A
                         
  MyThread := TMyThread.Create(False);
  MyThread.Priority := tpNormal;
  MyThread.FreeOnTerminate := True;
  MyThread.Resume;

  TcpClient1.Sendln('$KE' + Char(CRbyte) + Char(LFbyte));
  TcpClient1.Sendln('$KE,PSW,SET,Laurent' + Char(CRbyte) + Char(LFbyte));
end;

procedure TForm1.OnDataReceive(Sender: TObject; Buf: PAnsiChar;
  var DataLen: Integer);
begin
 if(StrLComp(Buf, '#INF', 4) = 0) then
 begin
  ShowMessage( Buf );
 end;
end;

procedure TMyThread.Execute;
begin
  Form1.TcpClient1.Receiveln(buffer);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  TcpClient1.Close;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  TcpClient1.Sendln('$KE,REL,1,1' + Char(CRbyte) + Char(LFbyte));
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  TcpClient1.Sendln('$KE,REL,1,0' + Char(CRbyte) + Char(LFbyte));
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  TcpClient1.Sendln('$KE,INF' + Char(CRbyte) + Char(LFbyte));
end;

end.
